;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						OppenComPort()					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
OpenComPort(exPort,exBaud,exParity,exSysTimeOut,exByteTimeOut,exMultipleTimeOut)
{
	global outErr
	VarSetCapacity(outErr,255,0)
		
	ReadIntervalTimeout 		= %exByteTimeOut%
	ReadTotalTimeoutMultiplier  = %exMultipleTimeOut%
	ReadTotalTimeoutConstant	= %exSysTimeOut%
	WriteTotalTimeoutMultiplier = 1
	WriteTotalTimeoutConstant	= 100
		
	VarSetCapacity(Data, 20, 0)
	NumPut(ReadIntervalTimeout, Data, 0, "UInt")
	NumPut(ReadTotalTimeoutMultiplier, Data, 4, "UInt")
	NumPut(ReadTotalTimeoutConstant, Data, 8, "UInt")
	NumPut(WriteTotalTimeoutMultiplier, Data, 12, "UInt")
	NumPut(WriteTotalTimeoutConstant, Data, 16, "UInt")
	
	mode= baud=%exBaud% parity=%exParity% data=8 stop=1 dtr=on rts=on
	
	stringmid exPort, exPort, 4, 2	
	if !DllCall("M230\_eOpen", "Int", exPort, "str", mode, "Int", &Data, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						CloseComPort					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
CloseComPort(exPort)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eClose", "Int", exPort, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						OpenTcpPort()					; tcp/ip-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
OpenTcpPort(exPort, ipAddress, Delay)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	
	if !DllCall("M230\_eTcpOpen", "Int", exPort, "str", ipAddress, "Int", StrLen(ipAddress), "Int", Delay, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						TestComPort						;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
TestComPort(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eTest", "Int", exAddr, "str", outErr, "char")
		return false
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						OpenSession						; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
OpenSession(exAddr,exPass,exLevel,passwordType)
{
	global outErr
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eOpenSession", "Int", exAddr, "Int", passwordType, "char", exLevel, "str", exPass, "str", outErr, "char")
		return false
				
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVariantExecution			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVariantExecution(exAddr,cType)
{
	global outErr, cVariant=, cVariant1= ,cFlagFhaseAccounting=, cVariant_TaskGroup=
	VarSetCapacity(outErr,255,0)	
	VarSetCapacity(arr1,1024,0)
	VarSetCapacity(arr2,512,0)
	VarSetCapacity(arr3,4,0)
		
	if !DllCall("M230\_eReadVariantExecution", "Int", exAddr, "Int", cType, "str", arr1, "str", arr2, "str", arr3, "str", outErr, "char")
		return false
				
	stringsplit word_variant,arr1,;
	stringsplit word_variant_result,arr2,;
	
	; 
	loop 32
	{
		cVariant .= "<tr><td class='style6'>" . word_variant%A_Index% . "</td><td class='style5'>" . word_variant_result%A_Index% . "</td></tr>`n"				
		cVariant1 .= "<tr><td><td><td class='style10'>" . word_variant%A_Index% . "&nbsp;&nbsp;" . "</td><td class='style9'>" . word_variant_result%A_Index% . "&nbsp;" . "</td></tr>`n"
				
		cVariant_TaskGroup .= "<tr><td>" . word_variant%A_Index% . "</td><td>" . word_variant_result%A_Index% . "</td></tr>"
	}
	
	cVariant_TaskGroup := "<table cellpadding=0 cellspacing=3>" . cVariant_TaskGroup . "</table>"
	
	;   
	if (word_variant_result28 = "")
		cFlagFhaseAccounting = 0
	else
		cFlagFhaseAccounting = 1
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadStateWord					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadStateWord(exAddr,TypeCounter)
{
	global outErr, cStWord= ,cStWord1=, cStWord_TaskGroup=
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(arr1,2048,0)
	VarSetCapacity(arr2,512,0)
	VarSetCapacity(arr3,4,0)
	
	if !DllCall("M230\_eReadStateWord", "Int", exAddr, "str", arr1, "str", arr2, "str", arr3, "str", outErr, "char")
		return false
		
	CurentTypeCounter := TypeCounter
			
	stringsplit word_variant,arr1,;
	stringsplit word_variant_result,arr2,;
	
	loop %word_variant_result0%
	{
		stringleft name_err%A_Index%,word_variant%A_Index%,3	
		stringmid label_err%A_Index%,word_variant%A_Index%,6,StrLen(word_variant%A_Index%)-6	
		
		
		if (A_Index = 4)
		{
			if (CurentTypeCounter <> "205")&&(CurentTypeCounter <> "235")
			{
				if word_variant_result%A_Index%
				{
					cStWord .= "<tr bgcolor='#ffff99'><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED checked>" . name_err%A_Index% . "</td><td class='style6'>" . "  ADS" . "</td></tr>`n"				
					cStWord1 .= "<tr><td><td><td class='style10'>  ADS&nbsp;&nbsp;</td><td class='style9'></td>`n"						
					
					cStWord_TaskGroup .= "<tr><td>" . word_variant%A_Index% . "</td><td></td></tr>"
				}
				else
					cStWord .= "<tr><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED>" . name_err%A_Index% . "</td><td class='style6'>" . "  ADS" . "</td></tr>`n"					
					
				
			}
			else
			{
				if word_variant_result%A_Index%
				{
					cStWord .= "<tr bgcolor='#ffff99'><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED checked>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"				
					cStWord1 .= "<tr><td><td><td class='style10'>" . label_err%A_Index% . "&nbsp;&nbsp;</td><td class='style9'></td>`n"	

					cStWord_TaskGroup .= "<tr><td>" . word_variant%A_Index% . "</td><td></td></tr>"
				}
				else
					cStWord .= "<tr><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"
			}
		}
		else if (A_Index = 8)
		{
			if (CurentTypeCounter = "205")||(CurentTypeCounter = "235")
			{
				if word_variant_result%A_Index%
				{
					cStWord .= "<tr bgcolor='#ffff99'><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED checked>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"				
					cStWord1 .= "<tr><td><td><td class='style10'>" . label_err%A_Index% . "&nbsp;&nbsp;</td><td class='style9'></td>`n"	
					
					cStWord_TaskGroup .= "<tr><td>" . word_variant%A_Index% . "</td><td></td></tr>"
				}
				else
					cStWord .= "<tr><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"
			}		

		}
		else
		{
			if word_variant_result%A_Index%
			{
				cStWord .= "<tr bgcolor='#ffff99'><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED checked>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"				
				cStWord1 .= "<tr><td><td><td class='style10'>" . label_err%A_Index% . "&nbsp;&nbsp;</td><td class='style9'></td>`n"	
				
				cStWord_TaskGroup .= "<tr><td>" . word_variant%A_Index% . "</td><td></td></tr>"
			}
			else
				cStWord .= "<tr><td align='center' class='style5'>" . "<input type='checkbox' name='option1' DISABLED>" . name_err%A_Index% . "</td><td class='style6'>" . label_err%A_Index% . "</td></tr>`n"
				
					
		}	
		
		
	}
	
	if (cStWord_TaskGroup <> "")
	cStWord_TaskGroup := "<table cellpadding=0 cellspacing=3>" . cStWord_TaskGroup . "</table>"
	else
	cStWord_TaskGroup := "<table cellpadding=0 cellspacing=3></table>"

		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadIndicationTariff()					;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadIndicationTariff(exAddr,CurentTypeCounter)
{
	global outErr,cIndParamsA= ,cIndParamsA1= ,cIndParamsA2= ,cIndParamsR= ,cIndParamsR1= ,cIndParamsR2=
	global cIndParams_TaskGroup
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(autoParamsA,255,0)
	VarSetCapacity(manualParamsA,255,0)
	VarSetCapacity(autoParamsR,255,0)
	VarSetCapacity(manualParamsR,255,0)
	
	if !DllCall("M230\_eReadParamDisplayRate", "Int", exAddr, "str", autoParamsA, "str", manualParamsA, "str", autoParamsR, "str", manualParamsR, "str", outErr, "char")
		return false
	
	if (CurentTypeCounter <> "236")
	{
		;   ( ,  ,  )
		loop 6
		{
			;  ( ,  ,  )
			stringmid autoParamsA%A_Index%,autoParamsA,A_Index,1
			
			;  ( ,  ,   )
			stringmid manualParamsA%A_Index%,manualParamsA,A_Index,1
			
			;  ( ,  ,  )
			stringmid autoParamsR%A_Index%,autoParamsR,A_Index,1
			
			;  ( ,  ,   )
			stringmid manualParamsR%A_Index%,manualParamsR,A_Index,1
			
			; 
			if A_Index = 1
				label = 
			else if A_Index = 2
				label = 1
			else if A_Index = 3
				label = 2	
			else if A_Index = 4
				label = 3
			else if A_Index = 5
				label = 4	
			else if A_Index = 6
				label = 
				
			if (A_Index=6)
			{				
				if (CurentTypeCounter = "230")||(CurentTypeCounter = "233")||(CurentTypeCounter = "234")
				{
					; (A)
					if (autoParamsA%A_Index%=1)
					{
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' checked>" . label . "</td>"			
						cIndParamsA1 .= label . "`," . A_Space
					}
					else 
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "'>" . label . "</td>"		
					
							
					;  (A)
					if (manualParamsA%A_Index%=1)
					{
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "' checked>" . label . "</td></tr>`n"		
						cIndParamsA2 .= label . "`," . A_Space
					}
					else
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "'>" . label . "</td></tr>`n"	

					;  (R)
					if (autoParamsR%A_Index%=1)
					{
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "' checked>" . label . "</td>"			
						cIndParamsR1 .= label . "`," . A_Space
					}
					else 
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "'>" . label . "</td>"		
							
					;  (R)
					if (manualParamsR%A_Index%=1)
					{
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "' checked>" . label . "</td></tr>`n"		
						cIndParamsR2 .= label . "`," . A_Space
					}
					else
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "'>" . label . "</td></tr>`n"			
				}
				else if (CurentTypeCounter = "235")||(CurentTypeCounter = "205")||(CurentTypeCounter = "231")
				{		
					; (A)
					if (autoParamsA%A_Index%=1)
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' disabled checked>" . label . "</td>"			
					else 
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' disabled>" . label . "</td>"		
						
					;  (A)
					if (manualParamsA%A_Index%=1)
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "' disabled checked>" . label . "</td></tr>`n"		
					else
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "' disabled>" . label . "</td></tr>`n"	

					;  (R)
					if (autoParamsR%A_Index%=1)
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "' disabled checked>" . label . "</td>"			
					else 
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "' disabled>" . label . "</td>"		
							
					;  (R)
					if (manualParamsR%A_Index%=1)
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "' disabled checked>" . label . "</td></tr>`n"		
					else
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "' disabled>" . label . "</td></tr>`n"	
				}
			}
			else
			{
				if (CurentTypeCounter = "230")||(CurentTypeCounter = "233")||(CurentTypeCounter = "235")||(CurentTypeCounter = "234")
				{
					; (A)
					if (autoParamsA%A_Index%=1)
					{
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' checked>" . label . "</td>"			
						cIndParamsA1 .= label . "`," . A_Space
					}
					else 
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "'>" . label . "</td>"		
							
					;  (A)
					if (manualParamsA%A_Index%=1)
					{
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "' checked>" . label . "</td></tr>`n"		
						cIndParamsA2 .= label . "`," . A_Space
					}
					else
						cIndParamsA .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndA" . A_Index . "'>" . label . "</td></tr>`n"	

					;  (R)
					if (autoParamsR%A_Index%=1)
					{
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "' checked>" . label . "</td>"			
						cIndParamsR1 .= label . "`," . A_Space
					}
					else 
						cIndParamsR .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndR" . A_Index . "'>" . label . "</td>"		
							
					;  (R)
					if (manualParamsR%A_Index%=1)
					{
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "' checked>" . label . "</td></tr>`n"		
						cIndParamsR2 .= label . "`," . A_Space
					}
					else
						cIndParamsR .= "<td align='left' class='style5'>" . "<input type='checkbox' name='manualParamIndR" . A_Index . "'>" . label . "</td></tr>`n"	
				}		
				else if (CurentTypeCounter = "231")
				{
					; (A)
					if (autoParamsA%A_Index%=1)
					{
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' checked>" . label . "</td>"			
						cIndParamsA1 .= label . "`," . A_Space
					}
					else 
						cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "'>" . label . "</td>"		
							
					;  (R)
					if (autoParamsR%A_Index%=1)
					{
						cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "' checked>" . label . "</td></tr>`n"			
						cIndParamsA1 .= label . "`," . A_Space
					}
					else 
						cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "'>" . label . "</td></tr>`n"			
					
				}									
			}
		}
		
	}
	else
	{
		;   ( )
		loop 5
		{
			;  ( ,  ,  )
			stringmid autoParamsA%A_Index%,autoParamsA,A_Index,1
				
			;  ( ,  ,  )
			stringmid autoParamsR%A_Index%,autoParamsR,A_Index,1
		
			; 
			if A_Index = 1
				label = 
			else if A_Index = 2
				label = 1
			else if A_Index = 3
				label = 2	
			else if A_Index = 4
				label = 3
			else if A_Index = 5
				label = 4	
			else if A_Index = 6
				label = 	
			
			; (A)
			if (autoParamsA%A_Index%=1)
			{
				cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' checked>" . label . "</td>"			
				cIndParamsA1 .= label . "`," . A_Space
			}
			else 
				cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "'>" . label . "</td>"		
					
			;  (R)
			if (autoParamsR%A_Index%=1)
			{
				cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "' checked>" . label . "</td></tr>`n"			
				cIndParamsR1 .= label . "`," . A_Space
			}
			else 
				cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "'>" . label . "</td></tr>`n"												
			
		}
	}
	cIndParamsA .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
	cIndParamsR .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
	
	stringleft cIndParamsA1,cIndParamsA1,strlen(cIndParamsA1)-2
	stringleft cIndParamsA2,cIndParamsA2,strlen(cIndParamsA2)-2
	stringleft cIndParamsR1,cIndParamsR1,strlen(cIndParamsR1)-2
	stringleft cIndParamsR2,cIndParamsR2,strlen(cIndParamsR2)-2
	
	cIndParams_TaskGroup := autoParamsA . "; " . manualParamsA . "; " . autoParamsR . "; " . manualParamsR
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadIndicationTime()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadIndicationTime(exAddr,CurentTypeCounter)
{
	global outErr,cIndTime= ,cIndTime1= ,cIndFlag= ,cIndFlag1= ,cIndFlag2=, cIndTime_TaskGroup=
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(indFlag,255,0)
	VarSetCapacity(durationTime,4,0)
	VarSetCapacity(durationCurRate,4,0)
	VarSetCapacity(durationRate,4,0)
	VarSetCapacity(durationTimeout,4,0)
		
	if !DllCall("M230\_eReadParamDisplayTime", "Int", exAddr, "str", indFlag, "Int*", durationTime, "Int*", durationCurRate, "Int*", durationRate, "Int*", durationTimeout, "str", outErr, "char")
		return false
	
	;
	if (CurentTypeCounter = "230")||(CurentTypeCounter = "233")||(CurentTypeCounter = "234")
	{
		cIndTime := "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTime' value='" . durationTime . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationCurRate' value='" . durationCurRate . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationRate' value='" . durationRate . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTimeout' value='" . durationTimeout . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
		
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationTime . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationCurRate . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationRate . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationTimeout . "</td>`n"
	}
	else if (CurentTypeCounter = "235")||(CurentTypeCounter = "205")
	{
		cIndTime := "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTime' value='" . durationRate . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTimeout' value='" . durationTimeout . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
		
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationRate . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationTimeout . "</td>`n"
	} 
	else if (CurentTypeCounter = "231")||(CurentTypeCounter = "236")
	{
		cIndTime := "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTime' value='" . durationTime . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationCurRate' value='" . durationCurRate . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationRate' value='" . durationRate . "' /></td><td class='style5'> </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td class='style5'><input type='text' id='s1' name='durationTimeout' value='" . durationTimeout . "' /></td><td class='style5'>. </td></tr>`n"
		cIndTime .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
		
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationTime . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationCurRate . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationRate . "</td>`n"
		cIndTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . durationTimeout . "</td>`n"
	}
	
	;
	stringleft indFlagF7,indFlag,1
	stringright indFlagF6,indFlag,1
	
	if (indFlagF6=1)
	{
		cIndFlag .=  "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='indFlagF7' checked>" . "   " . "</td></tr>`n"	
		cIndFlag1 .=  "<tr><td><td><td class='style10'>   &nbsp;&nbsp;</td><td class='style9'></td>`n"
		
		cIndFlag_TaskGroup  .= "   ."
	}
	else 
	{
		cIndFlag .=  "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='indFlagF7'>" . "   " . "</td></tr>`n"		
		cIndFlag1 .=  "<tr><td><td><td class='style10'>   &nbsp;&nbsp;</td><td class='style9'></td>`n"
		
		cIndFlag_TaskGroup  .= "    ."
	}
	
	if (indFlagF7=1)
	{
		cIndFlag .=  "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='indFlagF6' checked>" . "  . " . "</td></tr>`n"			
		cIndFlag2 .=  "<tr><td><td><td class='style10'>  . &nbsp;&nbsp;</td><td class='style9'></td>`n",
		
		cIndFlag_TaskGroup  .= "/   . "
	}
	else 
	{
		cIndFlag .=  "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='indFlagF6'>" . "  . " . "</td></tr>`n"		
		cIndFlag2 .=  "<tr><td><td><td class='style10'>  . &nbsp;&nbsp;</td><td class='style9'></td>`n"
		
		cIndFlag_TaskGroup  .= "/    . "
	}
	
	cIndFlag .= "<tr><td>&nbsp</td><td>&nbsp</td></tr>`n<tr><td>&nbsp</td><td>&nbsp</td></tr>`n<tr><td>&nbsp</td><td>&nbsp</td></tr>`n<tr><td>&nbsp</td><td>&nbsp</td></tr>`n"

	cIndTime_TaskGroup := durationTime . "," . durationCurRate . "," . durationRate . "," . durationTimeout . ";" . cIndFlag_TaskGroup
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamDisplayAdd()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamDisplayAdd(exAddr)
{
	global outErr, cIndAdd= 
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(typeIndParams,255,0)
	VarSetCapacity(massIndParams,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadParamDisplayAdd", "Int", exAddr, "str", typeIndParams, "str", massIndParams, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordTypeIndParams,typeIndParams,;
	stringsplit wordMassIndParams,massIndParams,;
	
	; 
	loop 5
	{
		if (wordMassIndParams%A_Index%=1)
			cIndAddMigData%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index . "' checked>" . wordTypeIndParams%A_Index% . "</td>`n"			
		else 
			cIndAddMigData%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index . "'>" . wordTypeIndParams%A_Index% . "</td>`n"		
	}
	
	;
	loop 5
	{
		count := A_Index+5
		temp1 := wordMassIndParams%count%
		temp2 := wordTypeIndParams%count%
		
		if (A_Index<3)
		{	
			if (temp1=1)
				cIndAddTime%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+5 . "' checked>" . temp2 . "</td>`n"			
			else 
				cIndAddTime%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+5 . "'>" . temp2 . "</td>`n"		
		}
		else
			cIndAddTime%A_Index% .= "<td>&nbsp</td><td>&nbsp</td>`n"		
	}
	
	;
	loop 5
	{
		count := A_Index+7
		temp1 := wordMassIndParams%count%
		temp2 := wordTypeIndParams%count%
	
	
		if (A_Index<5)
		{	
			if (temp1=1)
				cIndAddLimit%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+7 . "' checked>" . temp2 . "</td>`n"			
			else 
				cIndAddLimit%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+7 . "'>" . temp2 . "</td>`n"		
		}
		else
			cIndAddLimit%A_Index% .= "<td>&nbsp</td><td>&nbsp</td>`n"		
	}
	
	;
	loop 5
	{
		count := A_Index+11
		temp1 := wordMassIndParams%count%
		temp2 := wordTypeIndParams%count%
	
	
		if (A_Index<2)
		{	
			if (temp1=1)
				cIndAddArch%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+11 . "' checked>" . temp2 . "</td>`n"			
			else 
				cIndAddArch%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+11 . "'>" . temp2 . "</td>`n"		
		}
		else
			cIndAddArch%A_Index% .= "<td>&nbsp</td><td>&nbsp</td>`n"		
	}
	
	;.
	loop 5
	{
		count := A_Index+12
		temp1 := wordMassIndParams%count%
		temp2 := wordTypeIndParams%count%
	
	
		if (A_Index<5)
		{	
			if (temp1=1)
				cIndAddDop%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+12 . "' checked>" . temp2 . "</td>`n"			
			else 
				cIndAddDop%A_Index% .= "<td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='wordMassIndParams" . A_Index+12 . "'>" . temp2 . "</td>`n"		
		}
		else
			cIndAddDop%A_Index% .= "<td>&nbsp</td><td>&nbsp</td>`n"		
	}
	
	
	;  
	loop 5
	{
		par1 := cIndAddMigData%A_Index%
		par2 := cIndAddTime%A_Index%
		par3 := cIndAddLimit%A_Index%
		par4 := cIndAddArch%A_Index%
		par5 := cIndAddDop%A_Index%
	
		cIndAdd .= "<tr>`n" . par1 . par2 . par3 . par4 . par5 . "</tr>`n"
	}
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamDisplayRateAdd()		;    231
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamDisplayRateAdd(exAddr)
{
	global outErr, cIndAdd= ,cIndParamsA= , cIndParamsA1= , cIndParamsR1=
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(enAParams1,255,0)
	VarSetCapacity(enRParams1,255,0)
	VarSetCapacity(powerARParams1,255,0)
	VarSetCapacity(UPowerParams1,255,0)
	VarSetCapacity(IParams1,255,0)
	VarSetCapacity(timeParams1,255,0)
	
	if !result := DllCall("M230\_eReadParamDisplayRateAdd", "Int", addr, "str", enAParams1, "str", enRParams1, "str", powerARParams1, "str", UPowerParams1, "str", IParams1, "str", timeParams1, "str", outErr, "char")
		return false
		
	;   ( )
	loop 5
	{
		;  ( ,  ,  )
		stringmid autoParamsA%A_Index%,enAParams1,A_Index,1
			
		;  ( ,  ,  )
		stringmid autoParamsR%A_Index%,enRParams1,A_Index,1
	
		; 
		if A_Index = 1
			label = 
		else if A_Index = 2
			label = 1
		else if A_Index = 3
			label = 2	
		else if A_Index = 4
			label = 3
		else if A_Index = 5
			label = 4	
		
		; (A)
		if (autoParamsA%A_Index%=1)
		{
			cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "' checked>" . label . "</td>"			
			cIndParamsA1 .= label . "`," . A_Space
		}
		else 
			cIndParamsA .= "<tr><td>&nbsp</td><td align='left' class='style5'>" . "<input type='checkbox' name='autoParamIndA" . A_Index . "'>" . label . "</td>"		
				
		;  (R)
		if (autoParamsR%A_Index%=1)
		{
			cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "' checked>" . label . "</td></tr>`n"			
			cIndParamsR1 .= label . "`," . A_Space
		}
		else 
			cIndParamsA .= "<td align='left' class='style5'><input type='checkbox' name='autoParamIndR" . A_Index . "'>" . label . "</td></tr>`n"												
		
	}
	
	cIndParamsA .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
	cIndParamsR .= "<tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>`n"
	
	stringleft cIndParamsA1,cIndParamsA1,strlen(cIndParamsA1)-2
	stringleft cIndParamsR1,cIndParamsR1,strlen(cIndParamsR1)-2
	
	;     (. .)
	loop 8
	{
		stringmid PowerA%A_Index%,powerARParams1,A_Index,1
		stringmid PowerU%A_Index%,UPowerParams1,A_Index,1
		stringmid Curent%A_Index%,IParams1,A_Index,1
		stringmid Time%A_Index%,timeParams1,A_Index,1
		
		; 
		if A_Index = 8
		{
			; 
			label = 3
			if (PowerA%A_Index%=1)
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;  1-2	
			label = 12
			if (PowerU%A_Index%=1)
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"		

			;. 
			label = 2
			if (Curent%A_Index%=1)
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"			
		}	
		else if A_Index = 7
		{
			; 
			label = 2
			if (PowerA%A_Index%=1)
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	
								
			;	
			label = 3
			if (PowerU%A_Index%=1)
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"	
				
			;. 
			label = 1
			if (Curent%A_Index%=1)
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
			
		}
		else if A_Index = 6
		{
			; 
			label = 1
			if (PowerA%A_Index%=1)
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;	
			label = 2
			if (PowerU%A_Index%=1)
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 
			if (Curent%A_Index%=1)
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
		}
		else if A_Index = 5
		{
			; 
			label = 
			if (PowerA%A_Index%=1)
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;	
			label = 1
			if (PowerU%A_Index%=1)
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 3
			if (Curent%A_Index%=1)
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"	
				
			;. 
			label = PLC
			if (Time%A_Index%=1)
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
		}
		else if A_Index = 4
		{
			; 
			label = 3
			if (PowerA%A_Index%=1)
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			if (PowerU%A_Index%=1)
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"	
				
			;
			label = 2
			if (Curent%A_Index%=1)
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 
			if (Time%A_Index%=1)
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
		}	
		else if A_Index = 3
		{
			; 
			label = 2
			if (PowerA%A_Index%=1)
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			if (PowerU%A_Index%=1)
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 1
			if (Curent%A_Index%=1)
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 
			if (Time%A_Index%=1)
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
		}
		else if A_Index = 2
		{
			; 
			label = 1	
			if (PowerA%A_Index%=1)
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			if (PowerU%A_Index%=1)
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			; 2-3
			label = 23
			if (Curent%A_Index%=1)
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"

			;. 
			label = 
			if (Time%A_Index%=1)
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
		}
		else if A_Index = 1
		{
			; 
			label = 
			if (PowerA%A_Index%=1)
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"

			; 	
			if (PowerU%A_Index%=1)
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			; 1-3
			label = 13
			if (Curent%A_Index%=1)
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 3
			if (Time%A_Index%=1)
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
		}
	}
		
	stringsplit parr1,par1,`n
	stringsplit parr2,par2,`n
	stringsplit parr3,par3,`n
	stringsplit parr4,par4,`n
	stringsplit parr5,par5,`n
	stringsplit parr6,par6,`n
	stringsplit parr7,par7,`n
	stringsplit parr8,par8,`n
		
	temp1 := parr14	
	parr14 := parr12	
	parr12 := temp1	
			
	temp1 := parr24	
	parr24 := parr22	
	parr22 := temp1				
		
	temp1 := parr34	
	parr34 := parr32	
	parr32 := temp1			
		
	temp1 := parr43		
	parr44 := parr41	
	parr43 := parr42	
	parr42 := temp1	
	parr41 := "<td>&nbsp</td><td>&nbsp</td>"	
	
	temp1 := parr53	
	parr54 := parr51	
	parr53 := parr52	
	parr52 := temp1	
	parr51 := "<td>&nbsp</td><td>&nbsp</td>"
	
	temp1 := parr64
	temp2 := parr62
	parr64 := parr63
	parr63 := temp1
	parr62 := parr61
	parr61 := temp2
	
	temp1 := parr73
	parr73 := parr71
	parr71 := temp1	
	parr74 := "<td>&nbsp</td><td>&nbsp</td>"	
		
	count := 4	
	loop 4
	{
		cIndAdd .= "<tr>`n" . parr1%count% . "`n" . parr2%count% . "`n" . parr3%count% . "`n" . parr4%count% . "`n" . parr5%count% . "`n" . parr6%count% . "`n" . parr7%A_Index% . "`n" . parr8%A_Index% . "`n</tr>`n"
	
		count -= 1 
	}
	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamDisplayRateAdd_236()		;    236
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamDisplayRateAdd_236(exAddr)
{
	global outErr, cIndAdd= ,cIndAdd_2= ,cIndAdd_3=
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(ind_1,255,0)
	VarSetCapacity(ind_2,255,0)
	VarSetCapacity(ind_3,255,0)
	VarSetCapacity(ind_4,255,0)
	VarSetCapacity(ind_5,255,0)
		
	if !result := DllCall("M230\_eReadParamDisplayRateAdd_236", "Int", addr, "str", ind_1, "str", ind_2, "str", ind_3, "str", ind_4, "str", ind_5, "str", outErr, "char")
		return false
		
	;     (. .)
	loop 8
	{
		stringmid PowerA%A_Index%,ind_1,A_Index,1
		stringmid PowerU%A_Index%,ind_2,A_Index,1
		stringmid Curent%A_Index%,ind_3,A_Index,1
		stringmid Time%A_Index%,ind_4,A_Index,1
		stringmid Cover%A_Index%,ind_5,A_Index,1
		
		; 
		if A_Index = 8
		{
			; 
			label = 3
			if (PowerA%A_Index%=1)
			{
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " Q(" . label . ")`,"
			}
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;  1-2	
			label = 12
			if (PowerU%A_Index%=1)
			{
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"		

			;. 
			label = 2
			if (Curent%A_Index%=1)
			{
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " cosF(" . label . ")`,"
			}
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"		

			;PLC
			label = PLC
			if (Time%A_Index%=1)
			{
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " " . label . "`,"
			}
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"			

				
		}	
		else if A_Index = 7
		{
			; 
			label = 2
			if (PowerA%A_Index%=1)
			{
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " Q(" . label . ")`,"
			}
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	
								
			;	
			label = 3
			if (PowerU%A_Index%=1)
			{
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " U(" . label . ")`,"
			}
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"	
				
			;. 
			label = 1
			if (Curent%A_Index%=1)
			{
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " cosF(" . label . ")`,"
			}
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 
			if (Time%A_Index%=1)
			{
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " " . label . "`,"
			}
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"	
			
		}
		else if A_Index = 6
		{
			; 
			label = 1
			if (PowerA%A_Index%=1)
			{
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " Q(" . label . ")`,"
			}
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;	
			label = 2
			if (PowerU%A_Index%=1)
			{
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " U(" . label . ")`,"
			}
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 
			if (Curent%A_Index%=1)
			{
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " cosF(" . label . ")`,"
			}
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 
			if (Time%A_Index%=1)
			{
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " " . label . "`,"
			}
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"	
				
		}
		else if A_Index = 5
		{
			; 
			label = 
			if (PowerA%A_Index%=1)
			{
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " Q(" . label . ")`,"
			}
			else
				par2 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			;	
			label = 1
			if (PowerU%A_Index%=1)
			{
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " U(" . label . ")`,"
			}
			else
				par4 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 3
			if (Curent%A_Index%=1)
			{
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " I(" . label . ")`,"
			}
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"	
				
			;
			label = 1
			if (Time%A_Index%=1)
			{
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
				
			;    
			label = 
			if (Cover%A_Index%=1)
			{
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " time(" . label . ")`,"
			}
			else
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "'>" . label . "</td>`n"	
		}
		else if A_Index = 4
		{
			; 
			label = 3
			if (PowerA%A_Index%=1)
			{
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " P(" . label . ")`,"
			}
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			label = 3
			if (PowerU%A_Index%=1)
			{
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " S(" . label . ")`,"
			}
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"	
				
			;
			label = 2
			if (Curent%A_Index%=1)
			{
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " I(" . label . ")`,"
			}
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 2
			if (Time%A_Index%=1)
			{
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
				
			; 
			label = .
			if (Cover%A_Index%=1)
			{
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " time(" . label . ")`,"
			}
			else
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "'>" . label . "</td>`n"		
		}	
		else if A_Index = 3
		{
			; 
			label = 2
			if (PowerA%A_Index%=1)
			{
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " P(" . label . ")`,"
			}
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			if (PowerU%A_Index%=1)
			{
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " S(" . label . ")`,"
			}
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 1
			if (Curent%A_Index%=1)
			{
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " I(" . label . ")`,"
			}
			else
				par5 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = 3
			if (Time%A_Index%=1)
			{
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par9 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
				
			;     
			label = ...
			if (Cover%A_Index%=1)
			{
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " time(" . label . ")`,"
			}
			else
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "'>" . label . "</td>`n"		
		}
		else if A_Index = 2
		{
			; 
			label = 1	
			if (PowerA%A_Index%=1)
			{
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " P(" . label . ")`,"
			}
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"	

			; 	
			if (PowerU%A_Index%=1)
			{
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " S(" . label . ")`,"
			}
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			; 2-3
			label = 23
			if (Curent%A_Index%=1)
			{
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"

			;. 
			label = 
			if (Time%A_Index%=1)
			{
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " " . label . "`,"
			}
			else
				par8 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
				
			;    . 
			label = ...
			if (Cover%A_Index%=1)
			{
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " time(" . label . ")`,"
			}
			else
				par1a .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "'>" . label . "</td>`n"		
		}
		else if A_Index = 1
		{
			; 
			label = 
			if (PowerA%A_Index%=1)
			{
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " P(" . label . ")`,"
			}
			else
				par1 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerA" . A_Index . "'>" . label . "</td>`n"

			; 	
			if (PowerU%A_Index%=1)
			{
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " S(" . label . ")`,"
			}
			else
				par3 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='PowerU" . A_Index . "'>" . label . "</td>`n"
				
			; 1-3
			label = 13
			if (Curent%A_Index%=1)
			{
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " (" . label . ")`,"
			}
			else
				par7 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Curent" . A_Index . "'>" . label . "</td>`n"
				
			;. 
			label = 3
			if (Time%A_Index%=1)
			{
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " cosF(" . label . ")`,"
			}
			else
				par6 .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Time" . A_Index . "'>" . label . "</td>`n"
				
			;
			label = .
			if (Cover%A_Index%=1)
			{
				par1b .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "' checked>" . label . "</td>`n"	
				cIndAdd_3 .= " " . label . "`,"
			}
			else
				par1b .= "<td>&nbsp</td><td align='left' class='style5'><input type='checkbox' name='Cover" . A_Index . "'>" . label . "</td>`n"	

			
		}
	}
		
	stringsplit parr1,par1,`n
	stringsplit parr2,par2,`n
	stringsplit parr3,par3,`n
	stringsplit parr4,par4,`n
	stringsplit parr5,par5,`n
	stringsplit parr6,par6,`n
	stringsplit parr7,par7,`n
	stringsplit parr8,par8,`n
	stringsplit parr9,par9,`n
	stringsplit parr1a,par1a,`n
	stringsplit parr1b,par1b,`n
		
	temp1 := parr14	
	parr14 := parr12	
	parr12 := temp1	
			
	temp1 := parr24	
	parr24 := parr22	
	parr22 := temp1				
		
	temp1 := parr34	
	parr34 := parr32	
	parr32 := temp1			
		
	temp1 := parr43		
	parr44 := parr41	
	parr43 := parr42	
	parr42 := temp1	
	parr41 := "<td>&nbsp</td><td>&nbsp</td>"	
	
	temp1 := parr53	
	parr54 := parr51	
	parr53 := parr52	
	parr52 := temp1	
	parr51 := "<td>&nbsp</td><td>&nbsp</td>"
	
	temp1 := parr64
	temp2 := parr62
	parr64 := parr63
	parr63 := temp1
	parr62 := parr61
	parr61 := temp2
	
	temp1 := parr73
	parr73 := parr71
	parr71 := temp1	
	parr74 := "<td>&nbsp</td><td>&nbsp</td>"	
	
	;msgbox %parr93%
	temp1 := parr93
	parr93 := parr91
	parr91 := temp1	
	parr94 := "<td>&nbsp</td><td>&nbsp</td>"	
		
	count := 4	
	loop 4
	{
		cIndAdd .= "<tr>`n" . parr1%count% . "`n" . parr2%count% . "`n" . parr3%count% . "`n" . parr4%count% . "`n" . parr5%count% . "`n" . parr6%count% . "`n" . parr7%A_Index% . "`n" . parr8%A_Index% . "`n</tr>`n"
	
		cIndAdd_2 .= "<tr>`n" . parr9%A_Index% . parr1a%A_Index% . parr1b%A_Index% . "`n</tr>`n"
	
		count -= 1 
	}
	
	if (cIndAdd_3 <> "")
	{
		stringtrimright cIndAdd_3,cIndAdd_3,1
	
		cIndAdd_3=
		(
		<tr><td><td><td class="style3">&nbsp;</td>
		<tr><td><td><td class="style3"> :</td><td class="style9"></td>
		<tr><td><td><td class="style10">&nbsp;&nbsp;</td><td class="style9">%cIndAdd_3%</td>
		)
	}
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplayRate()			;   231
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplayRateAdd(exAddr,enAParams,enRParams,powerARParams,UPowerParams,IParams,timeParams)
{
	global outErr

	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteParamDisplayRateAdd", "Int", exAddr, "str", enAParams, "str", enRParams, "str", powerARParams, "str", UPowerParams, "str", IParams, "str", timeParams, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplayRate_236()			; .   236
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplayRateAdd_236(exAddr,powerARParams,UPowerParams,IParams,timeParams,coverParams)
{
	global outErr

	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteParamDisplayRateAdd_236", "Int", exAddr, "str", powerARParams, "str", UPowerParams, "str", IParams, "str", timeParams, "str", coverParams, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplayRate()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplayRate(exAddr,autoParamsA,manualParamsA,autoParamsR,manualParamsR)
{
	global outErr

	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteParamDisplayRate", "Int", exAddr, "str", autoParamsA, "str", manualParamsA, "str", autoParamsR, "str", manualParamsR, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplayTime()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplayTime(exAddr,delayFlags,durationTime,durationCurRate,durationRate,durationTimeout)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteParamDisplayTime", "Int", exAddr, "str", delayFlags, "Int", durationTime, "Int", durationCurRate, "Int", durationRate, "Int", durationTimeout, "str", outErr, "char")
	
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamDisplayAdd()			;   ()
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamDisplayAdd(exAddr,migParams,datatimeParams,limitParams,archiveParams,addParams)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteParamDisplayAdd", "Int", exAddr, "str", migParams, "str", datatimeParams, "str", limitParams, "str", archiveParams, "str", addParams, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEnergyReset()				;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEnergyReset(exAddr,rateNum)
{	
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadResetEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All

	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0
	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPhaseEnergy()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPhaseEnergy(exAddr,rateNum)
{	
	global outErr, cEnergy_f1= ,cEnergy_f2= , cEnergy_f3=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadPhaseEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordEnergyPhase,energyMass,;	
		
	cEnergy_f1 := wordEnergyPhase1
	cEnergy_f2 := wordEnergyPhase2
	cEnergy_f3 := wordEnergyPhase3
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentYearEnergy()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentYearEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2= , cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadCurrentYearEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All

	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyCurrentYearEnergy()	;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEarlyCurrentYearEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadEarlyCurrentYearEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPrevYearEnergy()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPrevYearEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadPrevYearEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyPrevYearEnergy()		;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEarlyPrevYearEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadEarlyPrevYearEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadMonthEnergy()				;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMonthEnergy(exAddr,rateNum,monthNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadMonthEnergy", "Int", exAddr, "Int", monthNum, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyMonthEnergy()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEarlyMonthEnergy(exAddr,rateNum,monthNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadEarlyMonthEnergy", "Int", exAddr, "Int", monthNum, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyMonthEnergy()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadMemEarlyMonthEnergy(exAddr,rateNum,monthNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)

	if !DllCall("M230\_eReadMemEarlyMonthEnergy", "Int", exAddr, "Int", monthNum, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentDayEnergy()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentDayEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadCurrentDayEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyCurrentDayEnergy()		;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEarlyCurrentDayEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadEarlyCurrentDayEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPrevDayEnergy()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPrevDayEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadPrevDayEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLoss()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLoss(exAddr)
{
	global outErr, cPowerLoss =
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(f1,4,0)
	VarSetCapacity(f2,4,0)
	VarSetCapacity(f3,4,0)
	VarSetCapacity(f4,4,0)
	VarSetCapacity(f5,4,0)
	VarSetCapacity(f6,4,0)
			
	if !DllCall("M230\_eReadPowerLoss", "Int", exAddr, "int*", f1, "int*", f2, "int*", f3, "int*", f4, "int*", f5, "int*", f6, "str", outErr, "char")
		return false
		
	cPowerLoss = %f1%,%f2%,%f3%,%f4%,%f5%,%f6%
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLoss()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLoss(exAddr,cf1,cf2,cf3,cf4,cf5,cf6)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWritePowerLoss", "Int", exAddr, "Int", cf1, "Int", cf2, "Int", cf3, "Int", cf4, "Int", cf5, "Int", cf6, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLossFlag()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLossFlag(exAddr,cf1,cf2)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWritePowerLossFlag", "Int", exAddr, "Int", cf1, "Int", cf2, outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteSecondaryTime()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteSecondaryTime(exAddr,timeU,timeF)
{
	global outErr
	VarSetCapacity(outErr,255,0)
		
	res := DllCall("M230\_eWriteSecondaryTime", "Int", exAddr, "Int", timeU, "Int", timeF, outErr, "char")
	
	if (res = 0)
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLossFlagFlag()			;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLossFlag(exAddr)
{
	global outErr, cPowerLossFlag =
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(f1,4,0)
	VarSetCapacity(f2,4,0)
				
	if !DllCall("M230\_eReadPowerLossFlag", "Int", exAddr, "int*", f1, "int*", f2, "str", outErr, "char")
		return false
		
	cPowerLossFlag = %f1%,%f2%
	
return true
}


;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEarlyPrevDayEnergy()		;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEarlyPrevDayEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=, cEnergy_A1_TaskGroup=, cEnergy_A2_TaskGroup=, cEnergy_R1_TaskGroup=, cEnergy_R2_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadEarlyPrevDayEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4
	
	StringReplace cEnergy_A1_TaskGroup, cEnergy_A1, `, , `. , All
	StringReplace cEnergy_A2_TaskGroup, cEnergy_A2, `, , `. , All
	StringReplace cEnergy_R1_TaskGroup, cEnergy_R1, `, , `. , All
	StringReplace cEnergy_R2_TaskGroup, cEnergy_R2, `, , `. , All
	
	setformat float, .3
	cEnergy_A1_TaskGroup += 0.0
	cEnergy_A2_TaskGroup += 0.0
	cEnergy_R1_TaskGroup += 0.0
	cEnergy_R2_TaskGroup += 0.0

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerParam()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerParam(exAddr,powerType,phaseNum)
{
	global outErr, cPower=, cPower_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(power,255,0)
		
	if !DllCall("M230\_eReadPowerParam", "Int", exAddr, "Int", powerType, "Int", phaseNum, "str", power, "str", outErr, "char")
		return false
	
	cPower := power
	
	StringReplace cPower_TaskGroup, cPower, `, , `. , All
		
	setformat float, .3
	cPower_TaskGroup += 0.0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerCoefParam()			; . 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerCoefParam(exAddr,phaseNum)
{
	global outErr, cCoeff=, cCoeff_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerCoef,255,0)
		
	if !DllCall("M230\_eReadPowerCoefParam", "Int", exAddr, "Int", phaseNum, "str", powerCoef, "str", outErr, "char")
		return false
	
	cCoeff := powerCoef
	
	StringReplace cCoeff_TaskGroup, cCoeff, `, , `. , All
		
	setformat float, .3
	cCoeff_TaskGroup += 0.0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVoltageParam()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVoltageParam(exAddr,phaseNum)
{
	global outErr, cVoltage=, cVoltage_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(voltage,255,0)
		
	if !DllCall("M230\_eReadVoltageParam", "Int", exAddr, "Int", phaseNum, "str", voltage, "str", outErr, "char")
		return false
	
	cVoltage:= voltage
	
	StringReplace cVoltage_TaskGroup, cVoltage, `, , `. , All
		
	setformat float, .3
	cVoltage_TaskGroup += 0.0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentParam()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentParam(exAddr,phaseNum)
{
	global outErr, cCurrent=, cCurrent_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(current,255,0)
		
	if !DllCall("M230\_eReadCurrentParam", "Int", exAddr, "Int", phaseNum, "str", current, "str", outErr, "char")
		return false
	
	cCurrent:= current
	
	StringReplace cCurrent_TaskGroup, cCurrent, `, , `. , All
		
	setformat float, .3
	cCurrent_TaskGroup += 0.0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadFrequencyParam()			; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadFrequencyParam(exAddr)
{
	global outErr, cFrequency=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(param,255,0)
		
	if !DllCall("M230\_eReadFrequencyParam", "Int", exAddr, "str", param, "str", outErr, "char")
		return false
	
	cFrequency:= param
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPhaseAngleParam()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPhaseAngleParam(exAddr,phaseNum)
{
	global outErr, cPhaseAngle=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(phaseAngle,255,0)
		
	if !DllCall("M230\_eReadPhaseAngleParam", "Int", exAddr, "Int", phaseNum, "str", phaseAngle, "str", outErr, "char")
		return false
	
	cPhaseAngle := phaseAngle
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						FixationData()					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
FixationData(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eFixationData", "Int", exAddr, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerFixationParam()		;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerFixationParam(exAddr,fPowerType)
{
	global outErr, cPowerFix=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(fPower,255,0)
	VarSetCapacity(separator,4,0)	
	
	if !DllCall("M230\_eReadPowerFixationParam", "Int", exAddr, "Int", fPowerType, "str", fPower, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordPowerFix,fPower,;
	
	loop %wordPowerFix0%
		cPowerFix .= "<td class='style9'>" . wordPowerFix%A_Index% . "</td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadVoltageFixationParam()		;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadVoltageFixationParam(exAddr)
{
	global outErr, cVoltageFix=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(fVoltage,255,0)
	VarSetCapacity(separator,4,0)	
	
	if !DllCall("M230\_eReadVoltageFixationParam", "Int", exAddr, "str", fVoltage, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordVoltageFix,fVoltage,;
	
	loop % wordVoltageFix0-1	;%
		cVoltageFix .= "<td class='style9'>" . wordVoltageFix%A_Index% . "</td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerCoefFixationParam() 	;  .
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerCoefFixationParam(exAddr)
{
	global outErr, cCoeffFix=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(fPowerCoef,255,0)
	VarSetCapacity(separator,4,0)	
	
	if !DllCall("M230\_eReadPowerCoefFixationParam", "Int", exAddr, "str", fPowerCoef, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordCoeffFix,fPowerCoef,;
	
	loop %wordCoeffFix0%
		cCoeffFix .= "<td class='style9'>" . wordCoeffFix%A_Index% . "</td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentFixationParam()		;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentFixationParam(exAddr)
{
	global outErr, cCurrentFix=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(fCurrent,255,0)
	VarSetCapacity(separator,4,0)	
	
	if !DllCall("M230\_eReadCurrentFixationParam", "Int", exAddr, "str", fCurrent, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordCurrentFix,fCurrent,;
	
	loop % wordCurrentFix0-1	;%
		cCurrentFix .= "<td class='style9'>" . wordCurrentFix%A_Index% . "</td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadFrequencyFixationParam()	;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadFrequencyFixationParam(exAddr)
{
	global outErr, cFrequency=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(fFrequency,255,0)
	VarSetCapacity(separator,4,0)	
	
	if !DllCall("M230\_eReadFrequencyFixationParam", "Int", addr, "str", fFrequency, "str", separator, "str", outErr, "char")
		return false
	
	stringsplit wordFrequencytFix,fFrequency,;
	
	cFrequency .= "<td class='style9'>" . wordCurrentFix1 . "</td>`n" . "<td class='style9'></td>`n" . "<td class='style9'></td>`n" . "<td class='style9'></td>`n"
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadFixationEnergy()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadFixationEnergy(exAddr,rateNum)
{
	global outErr, cEnergy_A1= ,cEnergy_A2= , cEnergy_R1= , cEnergy_R2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyMass,255,0)
	VarSetCapacity(separator,4,0)
	
	if !DllCall("M230\_eReadFixationEnergy", "Int", exAddr, "Int", rateNum, "str", energyMass, "str", separator, "str", outErr, "char")
		return false
		
	stringsplit wordEnergy,energyMass,;	
		
	cEnergy_A1 := wordEnergy1
	cEnergy_A2 := wordEnergy2
	cEnergy_R1 := wordEnergy3
	cEnergy_R2 := wordEnergy4	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadJournal()					; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadJournal(exAddr,massNum,num)
{
	global outErr, cJournal1= ,cJournal2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass1,255,0)
	VarSetCapacity(timeMass2,255,0)
		
	if !DllCall("M230\_eReadJournal", "Int", exAddr, "Int", massNum, "Int", num, "str", timeMass1, "str", timeMass2, "str", outErr, "char")
		return false
	
	cJournal1 := timeMass1
	cJournal2 := timeMass2
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadAddParamPKE()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadAddParamPKE(exAddr)
{
	global outErr, cJournal1= ,cJournal2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass1,255,0)
	VarSetCapacity(timeMass2,255,0)
	VarSetCapacity(separator,4,0)
		
	if !DllCall("M230\_eReadAddParamPKE", "Int", exAddr, "str", timeMass1, "str", timeMass2, "str", separator, "str", outErr, "char")
		return false
	
	cJournal1 := timeMass1
	cJournal2 := timeMass2
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSecondaryTime()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSecondaryTime(exAddr)
{
	global outErr, cJournal1= ,cJournal2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass1,4,0)
	VarSetCapacity(timeMass2,4,0)
	
		
	if !DllCall("M230\_eReadSecondaryTime", "Int", exAddr, "str", timeMass1, "str", timeMass2, "str", outErr, "char")
		return false
	
	transform cJournal1, Asc, %timeMass1%
	transform cJournal2, Asc, %timeMass2%
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCodeJournal()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCodeJournal(exAddr,num)
{
	global outErr, cJournal1= ,cJournal2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass,255,0)
	VarSetCapacity(posMass,255,0)
	VarSetCapacity(code,255,0)
	VarSetCapacity(queryNum,4,0)
		
	if !DllCall("M230\_eReadCodeJournal", "Int", exAddr, "Int", num, "str", timeMass, "Int*", queryNum, "str", posMass, "str", code, "str", outErr, "char")
		return false
		
	cJournal1 := timeMass . "  (. - " . queryNum . ")"
	cJournal2 := posMass . A_Space . code
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadStWordJournal()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadStWordJournal(exAddr,num)
{
	global outErr, cJournal1= ,cJournal2=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(timeMass,255,0)
	VarSetCapacity(posMass,255,0)
		
	if !DllCall("M230\_eReadStWordJournal", "Int", exAddr, "Int", num, "str", timeMass, "str", posMass, "str", outErr, "char")
		return false
		
	cJournal1 := timeMass 
	cJournal2 := posMass 
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCurrentTime()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCurrentTime(exAddr)
{
	global outErr, cTime= ,cTime1= ,cFlagSeason=, cTime_TaskGroup=, cFlagSeason_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(testTime,255,0)
	VarSetCapacity(testDate,255,0)
	VarSetCapacity(weekDay,255,0)
	VarSetCapacity(seasonFlag,4,0)
		
	if !DllCall("M230\_eReadCurrentTime", "Int", exAddr, "str", testTime, "str", testDate, "str", weekDay, "Int*", seasonFlag, "str", outErr, "char")
		return false
		
	cTime := testDate . A_Space . A_Space . testTime . A_Space . A_Space . weekDay
	
	cTime1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'>" . testDate . "</td>`n"
	cTime1 .= "<tr><td><td><td class='style10'>&nbsp;&nbsp;</td><td class='style9'>" . testTime . "</td>`n"
	cTime1 .= "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>" . weekDay . "</td>`n"
	
	cFlagSeason := seasonFlag
		
	if (cFlagSeason = 0)	
	cFlagSeason_TaskGroup = [] 
	else
	cFlagSeason_TaskGroup = []
	
	;      (  )
	;cTime_TaskGroup := weekDay . ", " . testDate . ", " . testTime . ", " . cFlagSeason_TaskGroup
	cTime_TaskGroup := weekDay . ", " . testDate . ", " . testTime
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SynchronizaionTime()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SynchronizaionTime(exAddr,FlagSeason)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M230\_eSynchronizaionTime", "Int", exAddr, "Int", FlagSeason, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetTransitionFlag()				;  .   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetTransitionFlag(exAddr,FlagAutoSeason)
{
	global outErr
	VarSetCapacity(outErr,255,0)
			
	if !DllCall("M230\_eSetTransitionFlag", "Int", exAddr, "Int", FlagAutoSeason, "str", outErr, "char")
		return false		
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadTransitionFlag()			;  .   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadTransitionFlag(exAddr)
{
	global outErr,cFlagAutoSeason= ,cindFlag10=,cindFlag10_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(seasonFlag,4,0)
	VarSetCapacity(restartFlag,4,0)
	VarSetCapacity(mFlag,4,0)
	VarSetCapacity(indFlag,255,0)
			
	if !DllCall("M230\_eReadTransitionFlag", "Int", exAddr, "Int*", seasonFlag, "Int*", restartFlag, "Int*", mFlag, "str", indFlag, "str", outErr, "char")
		return false		
	
		
	;   
	if (indFlag = "A+")&&(mFlag = 0)
	{
		cindFlag10 := "<option value='A+ .' selected='selected'>A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "A+ ."
	}		
	else if (indFlag = "A+")&&(mFlag = 1)
	{
		cindFlag10 := "<option value='A+ .' selected='selected'>A+ .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "A+ ."
	}
	else if (indFlag = "A-")&&(mFlag = 0)
	{
		cindFlag10 := "<option value='A- .' selected='selected'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "A- ."
	}
	else if (indFlag = "A-")&&(mFlag = 1)
	{
		cindFlag10 := "<option value='A- .' selected='selected'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "A- ."
	}
	else if (indFlag = "R+")&&(mFlag = 0)
	{
		cindFlag10 := "<option value='R+ .' selected='selected'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "R+ ."
	}
	else if (indFlag = "R+")&&(mFlag = 1)
	{
		cindFlag10 := "<option value='R+ .' selected='selected'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R- .'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "R+ ."
	}
	else if (indFlag = "R-")&&(mFlag = 0)
	{
		cindFlag10 := "<option value='R- .' selected='selected'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "R- ."
	}
	else if (indFlag = "R-")&&(mFlag = 1)
	{
		cindFlag10 := "<option value='R- .' selected='selected'>R- .</option>`n<option value='R- .'>R- .</option>`n<option value='R+ .'>R+ .</option>`n<option value='R+ .'>R+ .</option>`n<option value='A+ .' >A+ .</option>`n<option value='A+ .'>A+ .</option>`n<option value='A- .'>A- .</option>`n<option value='A- .'>A- .</option>`n<option value=' 0.5'> 0.5</option>"
		
		cindFlag10_TaskGroup := "R- ."
	}
	
	
	cFlagAutoSeason := seasonFlag
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSerialNumberOutputDate()	;      
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSerialNumberOutputDate(exAddr)
{
	global outErr, cSerialNumUI= ,cOutputDate=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(serialNum,255,0)
	VarSetCapacity(outputDate,255,0)
			
	if !DllCall("M230\_eReadSerialNumberOutputDate", "Int", exAddr, "str", serialNum, "str", outputDate, "str", outErr, "char")
		return false

	cSerialNumUI := serialNum
	cOutputDate := outputDate
				
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSoftVersion()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSoftVersion(exAddr)
{
	global outErr, cSoftVersion= 
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(softVersion,255,0)
				
	if !DllCall("M230\_eReadSoftVersion", "Int", exAddr, "str", softVersion, "str", outErr, "char")
		return false

	cSoftVersion := softVersion
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadTransitionTime()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadTransitionTime(exAddr)
{
	global outErr, cSeasonMount_Winter= ,cSeasonMount_Summer = ,cSeasonWeek_Winter= ,cSeasonWeek_Summer = ,cSeasonHour_Winter= ,cSeasonHour_Summer=, cSeasonTrans_TaskGroup1=, cSeasonTrans_TaskGroup2=
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(summerHour,255,0)
	VarSetCapacity(summerDay,255,0)
	VarSetCapacity(summerMonth,255,0)
	VarSetCapacity(winterHour,255,0)
	VarSetCapacity(winterDay,255,0)
	VarSetCapacity(winterMonth,255,0)
				
	if !DllCall("M230\_eReadTransitionTime", "Int", exAddr, "Int*", summerHour, "str", summerDay, "str", summerMonth, "Int*", winterHour, "str", winterDay, "str", winterMonth, "str", outErr, "char")
		return false

	cSeasonMount_Winter := summerMonth
	cSeasonMount_Summer := winterMonth
	
	cSeasonWeek_Winter := summerDay
	cSeasonWeek_Summer := winterDay
	
	cSeasonHour_Winter := summerHour
	cSeasonHour_Summer := winterHour
	
	cSeasonTrans_TaskGroup1 := cSeasonMount_Winter . ", " . cSeasonWeek_Winter . ", " . cSeasonHour_Winter
	cSeasonTrans_TaskGroup2 := cSeasonMount_Summer . ", " . cSeasonWeek_Summer . ", " . cSeasonHour_Summer
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteTransitionTime()			;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteTransitionTime(exAddr,sMonth,sDay,sHour,wMonth,wDay,wHour)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteTransitionTime", "Int", exAddr, "Int", sHour, "str", sDay, "str", sMonth, "Int", wHour, "str", wDay, "str", wMonth, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadLoadStWord()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadLoadStWord(exAddr)
{
	global outErr,cPowerControl= ,cEnergyControlFlag= ,cRelayFlag= ,cLimitFlag=, cStWord_TaskGroup=
	global cRelayFlag1= ,cEnergyControlFlag1= ,cPowerControl1= ,cImpulseControl1= 
	
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerControlFlag,4,0)
	VarSetCapacity(energyControlFlag,4,0)
	VarSetCapacity(limitFlag,255,0)
	VarSetCapacity(loadFlag,4,0)
	VarSetCapacity(ImpulseOutFlag,4,0)
				
	if !DllCall("M230\_eReadLoadStWord", "Int", exAddr, "Int*", powerControlFlag, "Int*", energyControlFlag, "str", limitFlag, "Int*", loadFlag, "Int*", ImpulseOutFlag, "str", outErr, "char")
		return false

	if energyControlFlag
	{
		cEnergyControlFlag := "<input type='checkbox' name='flagLimitEnergyControl' checked>"
		cEnergyControlFlag1 := "<tr><td><td><td class='style10'>   &nbsp;&nbsp;</td><td class='style9'></td>"
	}		
	else		
	{
		cEnergyControlFlag := "<input type='checkbox' name='flagLimitEnergyControl'>"	
		cEnergyControlFlag1 := "<tr><td><td><td class='style10'>   &nbsp;&nbsp;</td><td class='style9'></td>"
	}
		
	if powerControlFlag
	{
		cPowerControl := "<input type='checkbox' name='flagLimitPowerControl' checked>"
		cPowerControl1 := "<tr><td><td><td class='style10'>   </td><td class='style9'></td>"
	}
	else		
	{
		cPowerControl := "<input type='checkbox' name='flagLimitPowerControl'>"
		cPowerControl1 := "<tr><td><td><td class='style10'>   </td><td class='style9'></td>"
	}
	
	cLimitFlag := limitFlag	
	
	if loadFlag
	{
		cRelayFlag := "<td style='color: red; font-size: 14px; font-weight: bold;' align='left'>!</td>"
		cRelayFlag1 := "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>!</td>"
	}
	else
	{
		cRelayFlag := "<td style='color: green; font-size: 14px; font-weight: bold;' align='left'>!</td>"
		cRelayFlag1 := "<tr><td><td><td class='style10'> &nbsp;&nbsp;</td><td class='style9'>!</td>"
	}
		
	if ImpulseOutFlag
	{
		cImpulseControl1 = <input name='flagImpulseControl1' type="radio" value="tele" class="style5" onclick="location.href='select_impulse_ind'" /><span class="style5"></span><br>`n<input name='flagImpulseControl1' type="radio" value="rele" class="style5" checked onclick="location.href='select_impulse_ind'" /><span class="style5">. </span>
	}
	else
	{
		cImpulseControl1 = <input name='flagImpulseControl1' type="radio" value="tele" class="style5" onclick="location.href='select_impulse_ind'" checked /><span class="style5"></span><br>`n<input name='flagImpulseControl1' type="radio" value="rele" class="style5" onclick="location.href='select_impulse_ind'" /><span class="style5">. </span>
	}
	
			
	cStWord_TaskGroup := energyControlFlag . "," . powerControlFlag . "," . limitFlag . "," . loadFlag . "," . ImpulseOutFlag
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteLoadMode()					;/ 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteLoadMode(exAddr,loadFlag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteLoadMode", "Int", exAddr, "Int", loadFlag, "str", outErr, "char")
		return false
	
return true
}


;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteAddParamPKE()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteAddParamPKE(exAddr,PDZU1,PDZU2,NDZU1,NDZU2,PDZF1,PDZF2,NDZF1,NDZF2)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteAddParamPKE", "Int", exAddr, "int", PDZU1, "int", PDZU2, "int", NDZU1, "int", NDZU2, "int", PDZF1, "int", PDZF2, "int", NDZF1, "int", NDZF2,"str", outErr, "char")
		return false
	
return true
}




;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteIndicationMode()			;  	;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteIndicationMode(exAddr,Flag)
{
	global outErr
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteIndicationMode", "Int", exAddr, "Int", Flag, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteConstant()					;  (., .)  	;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteConstant(exAddr,Flag)
{
	global outErr
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteConstant", "Int", exAddr, "Int", Flag, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ResetDevice()					;  ""	;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ResetDevice(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eRestartDevice", "Int", exAddr, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteImpulseMode()				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteImpulseMode(exAddr,ImpulseOutflag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteImpulseMode", "Int", exAddr, "Int", ImpulseOutflag, "str", outErr, "char")
		return false
	
return true
}


;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadEnergyLimit()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadEnergyLimit(exAddr,tariff)
{
	global outErr,cEnergyLimit=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(energyLimit,4,0)
					
	if !DllCall("M230\_eReadEnergyLimit", "Int", exAddr, "Int", tariff, "Int*", energyLimit, "str", outErr, "char")
		return false

	cEnergyLimit := energyLimit
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLimit()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLimit(exAddr)
{
	global outErr,cPowerLimit=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerLimit,32,0)
					
	if !DllCall("M230\_eReadPowerLimit", "Int", exAddr, "Int*", powerLimit, "str", outErr, "char")
		return false

	cPowerLimit := powerLimit
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadPowerLimitTime()			;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadPowerLimitTime(exAddr)
{
	global outErr,cPowerLimitTime=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerLimitTime,32,0)

	if !DllCall("M230\_eReadPowerLimitTime", "Int", exAddr, "Int*", powerLimitTime, "str", outErr, "char")
		return false

	cPowerLimitTime := powerLimitTime
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteEnergyLimitControl()		;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteEnergyLimitControl(exAddr,energyFlag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWriteEnergyLimitControl", "Int", exAddr, "Int", energyFlag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLimitControl()		;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLimitControl(exAddr,limitFlag)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWritePowerLimitControl", "Int", exAddr, "Int", limitFlag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteEnergyLimit()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteEnergyLimit(exAddr,energyLimit,tariff)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWriteEnergyLimit", "Int", exAddr, "Int", tariff, "Int", energyLimit, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLimit()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLimit(exAddr,powerLimit)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWritePowerLimit", "Int", exAddr, "Int", powerLimit, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WritePowerLimitTime()			;     
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WritePowerLimitTime(exAddr,powerLimitTime)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWritePowerLimitTime", "Int", exAddr, "Int", powerLimitTime, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadRateMode()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadRateMode(exAddr)
{
	global outErr,cRateMode= ,cCurrentRate= ,cDefaultRate=, cRateMode_TaskGroup=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(rateMode,32,0)
	VarSetCapacity(currentRate,32,0)
	VarSetCapacity(defaultRate,32,0)
				
	if !DllCall("M230\_eReadRateMode", "Int", exAddr, "Int*", rateMode, "Int*", currentRate, "Int*", defaultRate, "str", outErr, "char")
		return false

	cRateMode := rateMode
	cCurrentRate := currentRate
	cDefaultRate := defaultRate
	
	if cRateMode
	cRateMode_TaskGroup = 
	else
	cRateMode_TaskGroup = 

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteRateMode()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteRateMode(exAddr,rateMode)
{
	global outErr
	VarSetCapacity(outErr,255,0)
						
	if !DllCall("M230\_eWriteRateMode", "Int", exAddr, "Int", rateMode, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadRateScale()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadRateScale(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eReadRateScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteRateScale()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteRateScale(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteRateScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadWeekendScale()				;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadWeekendScale(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eReadWeekendScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteWeekendScale()				;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteWeekendScale(exAddr,fName)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteWeekendScale", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadAddress()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadAddress(exAddr)
{
	global outErr, cNetAddr=
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eReadAddress", "Int", exAddr, "Int*", cAddr, "str", outErr, "char")
		return false

	cNetAddr := cAddr	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSecPowerProfile()			;   ( )
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSecPowerProfile(exAddr,TimeStart,TimeEnd,cType)
{
	global outErr
	global cCurTimeMass= ,cCurDateMass= ,cStWordMass= ,cPeriodMass= ,cAPowerMass1= ,cAPowerMass2= ,cRPowerMass1= ,cRPowerMass2=
	VarSetCapacity(outErr,255,0)
	
	VarSetCapacity(CurTimeMass,32000,0)	;  
	VarSetCapacity(CurDateMass,32000,0)	;  
	VarSetCapacity(StWordMass,32000,0) 	;  (- )
	VarSetCapacity(PeriodMass,32000,0)	; 
	VarSetCapacity(APowerMass1,32000,0)	;  (; )
	VarSetCapacity(APowerMass2,32000,0)	;  (; )
	VarSetCapacity(RPowerMass1,32000,0)	;  (; )
	VarSetCapacity(RPowerMass2,32000,0)	;  (; )
	VarSetCapacity(arr25,500,0)			;
	;TimeStart:="02.12.2009 17:00"		;  
	;TimeEnd:="02.12.2009 19:30"		; .
	;cType = 1 ; 233
	
	if !DllCall("M230\_eReadSecPowerProfile", "Int", exAddr, "Int", cType, "str", TimeStart, "str", TimeEnd,  "str", CurTimeMass, "str", curDateMass, "str", stWordMass, "str", periodMass, "str", APowerMass1, "str", APowerMass2, "str", RPowerMass1, "str", RPowerMass2, "str", arr25, "str", outErr, "char")
		return false
			
	cCurTimeMass := CurTimeMass	
	cCurDateMass := CurDateMass 	
	cStWordMass := StWordMass
	cPeriodMass := PeriodMass
	cAPowerMass1 := APowerMass1
	cAPowerMass2 := APowerMass2
	cRPowerMass1 := RPowerMass1	
	cRPowerMass2 := RPowerMass2	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadSecPowerProfile1()			;   ( )
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadSecPowerProfile1(exAddr,TimeStart,TimeEnd,cType)
{
	global outErr
	global cCurTimeMass= ,cCurDateMass= ,cStWordMass= ,cPeriodMass= ,cAPowerMass1= ,cAPowerMass2= ,cRPowerMass1= ,cRPowerMass2=
	VarSetCapacity(outErr,255,0)
	
	VarSetCapacity(CurTimeMass,32000,0)	;  
	VarSetCapacity(CurDateMass,32000,0)	;  
	VarSetCapacity(StWordMass,32000,0) 	;  (- )
	VarSetCapacity(PeriodMass,32000,0)	; 
	VarSetCapacity(APowerMass1,32000,0)	;  (; )
	VarSetCapacity(APowerMass2,32000,0)	;  (; )
	VarSetCapacity(RPowerMass1,32000,0)	;  (; )
	VarSetCapacity(RPowerMass2,32000,0)	;  (; )
	VarSetCapacity(arr25,500,0)			;
	;TimeStart:="02.12.2009 17:00"		;  
	;TimeEnd:="02.12.2009 19:30"		; .
	;cType = 1 ; 233
	
	if !DllCall("M230\_eReadSecPowerProfileTotal", "Int", exAddr, "Int", cType, "str", TimeStart, "str", TimeEnd,  "str", CurTimeMass, "str", curDateMass, "str", stWordMass, "str", periodMass, "str", APowerMass1, "str", APowerMass2, "str", RPowerMass1, "str", RPowerMass2, "str", arr25, "str", outErr, "char")
		return false
			
	cCurTimeMass := CurTimeMass	
	cCurDateMass := CurDateMass 	
	cStWordMass := StWordMass
	cPeriodMass := PeriodMass
	cAPowerMass1 := APowerMass1
	cAPowerMass2 := APowerMass2
	cRPowerMass1 := RPowerMass1	
	cRPowerMass2 := RPowerMass2	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteAddress()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteAddress(exAddr,newAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteAddress", "Int", exAddr, "Int", newAddr, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteSessionPassword()			; 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteSessionPassword(exAddr,level,prevPassword,setPassword,prevPasswType,setPasswType)
{
	num:=1
	global outErr
	VarSetCapacity(outErr,255,0)
		
	if !DllCall("M230\_eWriteSessionPassword", "Int", exAddr, "Int", prevPasswType, "Int", setPasswType, "Int", level, "str", prevPassword, "str", setPassword, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ConnectGsmModem					;  GSM  RF
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ConnectRFModem(SerialNumber)
{
	global outErr
	
	;      
	loop 8
	{
		stringmid AscByte,SerialNumber,A_Index,1
		transform AscByte,Asc, %AscByte%
		
		SetFormat integer, hex
		AscByte += 0
	
		if (AscByte < 0x10)
		{
			stringright AscByte, AscByte, 1
			AscByte = 0%AscByte%
		}
				
		stringmid AscByte, AscByte, 3, 2
		
		if (A_Index = 1)
			AscStr= %AscByte%	
		else
			AscStr = %AscStr%%AscByte%				
	}
	
	;ATZ
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(outMass,255,0)
	cmdMass:="41 54 5a 0d"

	if !DllCall("M230\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false	
	
	;AT&D2
	cmdMass:="41 54 26 44 32 0d"	
	if !DllCall("M230\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false	

	;ATD........
	cmdMass:="41 54 44" . AscStr . "`0d"
	if !DllCall("M230\_eWriteData", "str", cmdMass, "Int", StrLen(cmdMass), "str", outMass, "str", outErr, "char")
		return false		
	
	SetFormat integer, d
	AscByte += 0
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						InitPower()						;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
InitPower(exAddr,periodValue,flag)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)
	;flag=0   
	
	if !DllCall("M230\_eInitPower", "Int", exAddr, "Int", periodValue, "Int", flag, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadCoefTransf()				; . 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadCoefTransf(exAddr)
{
	global outErr, cCoefU= , cCoefI=
	
	VarSetCapacity(outErr,255,0)
		
	if !DllCall("M230\_eReadCoefTransf", "Int", exAddr, "Int*", coefU1, "Int*", coefI1, "str", outErr, "char")
		return false

	cCoefU := coefU1
	cCoefI := coefI1	
		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ConnectGsmModem					;  GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ConnectGsmModem(PhoneNumber, InitStr, Delay)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eConfigurationGSM", "str", PhoneNumber, "str", InitStr, "Int", Delay, "str", outErr, "char")
		return false	
	
return true
}


;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						DisconnectGsmModem				;   GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
DisconnectGsmModem()
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eDisconnectGSM", "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteATZtoGSMModem				; ATZ
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteATZtoGSMModem()
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteATZtoGSM", "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteATCBSTtoGSMModem			; AT+CBST
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteATCBSTtoGSMModem(InitStr)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eWriteATCBSTtoGSM", "str", InitStr, "Int", StrLen(InitStr), "str", outErr, "char")
		return false	
	
return true
}


;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteATD2toGSMModem				; AT&D2
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteATD2toGSMModem()
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteATD2toGSM", "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteATS7toGSMModem				; ATS7
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteATS7toGSMModem()
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteATS7toGSM", "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteATDtoGSMModem				; ATD
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteATDtoGSMModem(PhoneNumber, Delay)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteATDtoGSM", "str", PhoneNumber, "Int", StrLen(PhoneNumber), "Int", Delay, "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetEchoMode						;/ echo-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetEchoMode(echoMode)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eSetEchoMode", "Int", echoMode, "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						InitEnergy()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
InitEnergy(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eInitEnergy", "Int", exAddr, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ResetEnergy()					;  
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ResetEnergy(exAddr)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eResetEnergy", "Int", exAddr, "str", outErr, "char")
		return false

return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamGSMLock				;   GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamGSMLock(Speed, bitNum, StopbitNum, Parity, ChParityFlag, Delay, PauseByte)
{
	global outErr
	
	VarSetCapacity(outErr,255,0)

	if !DllCall("M230\_eWriteParamGSMLock", "Int", Speed, "Int", bitNum, "Int", StopbitNum, "Int", Parity, "Int", ChParityFlag, "Int", Delay, "Int", PauseByte, "str", outErr, "char")
		return false	
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetGSMFlag						;    GSM-
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetGSMFlag(gsmFlag)
{

	DllCall("M230\_eSetGSMFlag", "Int", gsmFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteParamOpticLink				;    
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteParamOpticLink(exAddr,typeInterfaceFlag,baudRate,multTimeout,parity,linkFlags)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(linkFlag,255,0)
	
	if !DllCall("M230\_eWriteParamOpticLink", "Int", exAddr, "Int", typeInterfaceFlag, "Int", baudRate, "Int", parity, "str", linkFlags, "Int", multTimeout, "str", outErr, "char")
		return false

		
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadParamInterfaceLink			;    	;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadParamInterfaceLink(exAddr)
{
	global outErr, cMultipleTimeOut=
	VarSetCapacity(outErr,255,0)
		
	if !DllCall("M230\_eReadParamInterfaceLink", "Int", exAddr, "int*", TimeOut, "str", outErr, "char")
		return false
	
	cMultipleTimeOut := TimeOut
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						WriteDayMaxRate()				;       
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
WriteDayMaxRate(exAddr,fName)
{
	global outErr 
	VarSetCapacity(outErr,255,0)

	if! DllCall("M230\_eWriteDayMaxRate", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadDayMaxRate()				;       
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadDayMaxRate(exAddr,fName)
{
	global outErr 
	VarSetCapacity(outErr,255,0)

	if! DllCall("M230\_eReadDayMaxRate", "Int", exAddr, "str", fName, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						ReadDayMaxPower()				;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
ReadDayMaxPower(exAddr)
{
	global outErr, cMonthMass=, cPowerMass=
	VarSetCapacity(outErr,255,0)
	VarSetCapacity(powerMass,1200,0)
	VarSetCapacity(monthMass,1200,0)
	VarSetCapacity(arr26,255,0)

	if! DllCall("M230\_eReadDayMaxPower", "Int", exAddr, "str", monthMass, "str", powerMass, "str", arr26, "str", outErr, "char")
		return false
	
	cMonthMass:=monthMass
	cPowerMass:=powerMass
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						InitMonthMax()					;   
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
InitMonthMax(exAddr)
{
	global outErr 
	VarSetCapacity(outErr,255,0)

	if! DllCall("M230\_eInitMonthMaxMass", "Int", exAddr, "str", outErr, "char")
		return false
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetEchoFlag						;  - 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetEchoFlag(echoFlag)
{

	DllCall("M230\_eSetEchoFlag", "Int", echoFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						SetTcpFlag						;  tcp/ip- 
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
SetTcpFlag(tcpFlag)
{

	DllCall("M230\_eSetTcpFlag", "Int", tcpFlag)
	
return true
}

;---------------------------------------------------------------------------------------------------------------------------------------------------------------
;Subroutine						TestOn()						;./.  ""
;---------------------------------------------------------------------------------------------------------------------------------------------------------------
TestOn(exAddr, flagMode)
{
	global outErr
	VarSetCapacity(outErr,255,0)
	
	if !DllCall("M230\_eTestOn", "Int", exAddr, "Int", flagMode, "str", outErr, "char")
		return false

return true
}



